' Web: http://mat.midlight.eu/wiki/index.php/Bascom_Proportional_Fonts
$nocompile

#if Not Varexist( "False")
   Const False = 0
   Const True = 1
#endif

Dim Lcd_tt_fontheight As Byte
Dim Lcd_tt_fontspacing As Byte                                                  ' ranging from -15 to +15, bias value 15

Dim Lcd_tt_chars As Byte
Dim Lcd_tt_rlecompressed As Bit
Dim Lcd_tt_chartable_ptr As Word
Dim Lcd_tt_blocksize As Byte
Dim Lcd_tt_fontdisplace As Byte

' Loads font data
Sub Lcd_tt_loadfont(bylabel Fonttable As Word)
   Lcd_tt_chartable_ptr = Fonttable
   LDS _DPTRL, {Lcd_tt_chartable_ptr}
   LDS _DPTRH, {Lcd_tt_chartable_ptr+1}
   Read Lcd_tt_fontheight
   Read Lcd_tt_fontspacing
   Lcd_tt_rlecompressed = Lcd_tt_fontspacing.5
   Lcd_tt_fontspacing = Lcd_tt_fontspacing And &H1F
   Read Lcd_tt_chars
   Lcd_tt_chartable_ptr = Lcd_tt_chartable_ptr + 3
   Lcd_tt_blocksize = Lcd_tt_fontheight + 7
   Lcd_tt_blocksize = Lcd_tt_blocksize / 8
   Lcd_tt_fontdisplace = Lcd_tt_blocksize * 8
End Sub

' Draws a text on the screen using the previously loaded font
Sub Lcd_tt_text(byval Text As String , Byval X As Word , Byval Y As Word , Byval Forecolor As Word)
   Local Stringindex As Byte
   Local Stringlength As Byte
   Local Stringpointer As Word
   Local Stringchar As Byte
   Local Charindex As Byte
   Local Tablechar As Byte
   Local Tempindex As Byte
   Local Fontdata As Byte
   Local Tempbyte As Byte
   Local Xpos As Word
   Local Previous As Byte
   Local Repeat As Byte
   Local Firstbyte As Byte

   Stringlength = Len(text) - 1
   Stringpointer = Varptr(text)
   For Stringindex = 0 To Stringlength
      Stringchar = Inp(stringpointer)
      Stringpointer = Stringpointer + 1

      ' search for char in chartable
      LDS _DPTRL, {Lcd_tt_chartable_ptr}
      LDS _DPTRH, {Lcd_tt_chartable_ptr+1}
      Fontdata = False
      For Charindex = 1 To Lcd_tt_chars
         Read Tablechar
         If Stringchar = Tablechar Then
            Tempindex = Lcd_tt_chars - Charindex                                ' jump to end of char table
            ___r23 = Tempindex
            Add _dptrl, R23
            ldi R23, 0
            adc _dptrh, R23
            Fontdata = True
            Exit For
         End If
      Next

      If Fontdata = True Then                                                   ' char is in chartable
         ' skip preceding chars in fonttable
         If 1 < Charindex Then
            Charindex = Charindex - 2
            For Stringchar = Charindex To 0 Step -1
               Read Tablechar                                                   ' char width
               If Lcd_tt_rlecompressed = True Then
                  Read Tablechar                                                ' font data byte size
               Else
                  Tablechar = Tablechar * Lcd_tt_blocksize
               End If
               ___r23 = Tablechar
               Add _dptrl, R23
               ldi R23, 0
               adc _dptrh, R23
            Next
         Else
            Charindex = Charindex - 1
         End If


         ' read font data and draw char
         Repeat = 0
         Firstbyte = True
         Read Tablechar                                                         ' char width
         If Lcd_tt_rlecompressed = True Then Read Charindex                     ' font data byte size, not needed now
         For Charindex = 1 To Lcd_tt_blocksize                                  ' blocks
            Xpos = X
            For Stringchar = 1 To Tablechar                                     ' width
               If Lcd_tt_rlecompressed = True Then
                  If Repeat = 0 Then
                     Read Fontdata
                     If Firstbyte = False Then
                        If Previous = Fontdata Then Read Repeat                 ' not first data byte and same as previous one
                     Else
                        Firstbyte = False
                     End If
                     Previous = Fontdata
                  Else
                     Repeat = Repeat - 1
                  End If
               Else
                  Read Fontdata
               End If
               For Tempindex = 7 To 0 Step -1                                   ' block
                  If Fontdata.tempindex = True Then
                     ' By changing the pixel draw function, other displays could be used as well
                     #if Varexist( "Ili9341")
                        Lcd_set_pixel Xpos , Y , Forecolor
                     #else
                        Pset Xpos , Y , 1
                     #endif
                  End If
                  Y = Y + 1
               Next
               Y = Y - 8
               Xpos = Xpos + 1
            Next
            Y = Y + 8
         Next

         X = X + Tablechar
         X = X - 15
         X = X + Lcd_tt_fontspacing
         Y = Y - Lcd_tt_fontdisplace
      End If
   Next
End Sub

' returns the width of a text using the loaded font
Function Lcd_tt_textwidth(byval Text As String) As Word
   Local Stringindex As Byte
   Local Stringlength As Byte
   Local Stringpointer As Word
   Local Stringchar As Byte
   Local Charindex As Byte
   Local Tablechar As Byte
   Local Tempindex As Byte
   Local Fontdata As Byte
   Local X As Word

   Stringlength = Len(text) - 1
   Stringpointer = Varptr(text)
   For Stringindex = 0 To Stringlength
      Stringchar = Inp(stringpointer)
      Stringpointer = Stringpointer + 1

      ' search for char in chartable
      LDS _DPTRL, {Lcd_tt_chartable_ptr}
      LDS _DPTRH, {Lcd_tt_chartable_ptr+1}
      Fontdata = False
      For Charindex = 1 To Lcd_tt_chars
         Read Tablechar
         If Stringchar = Tablechar Then
            Tempindex = Lcd_tt_chars - Charindex                                ' jump to end of char table
            ___r23 = Tempindex
            Add _dptrl, R23
            ldi R23, 0
            adc _dptrh, R23
            Fontdata = True
            Exit For
         End If
      Next

      If Fontdata = True Then                                                   ' char is in chartable
         ' skip preceding chars in fonttable
         If 1 < Charindex Then
            Charindex = Charindex - 2
            For Stringchar = Charindex To 0 Step -1
               Read Tablechar                                                   ' char width
               If Lcd_tt_rlecompressed = True Then
                  Read Tablechar                                                ' font data byte size
               Else
                  Tablechar = Tablechar * Lcd_tt_blocksize
               End If
               ___r23 = Tablechar
               Add _dptrl, R23
               ldi R23, 0
               adc _dptrh, R23
            Next
         Else
            Charindex = Charindex - 1
         End If

         ' read font data and draw char
         Read Tablechar                                                         ' char width
         X = X + Tablechar
         X = X - 15
         X = X + Lcd_tt_fontspacing
      End If
   Next
   Lcd_tt_textwidth = X
End Function